/* DIBUJAR05.C
**
** Definicin de Funciones auxiliares para programar grficos, si el/la
** estudiante no conoce el API de MS-Windows.
*/

#include <windows.h>
#include "dibujar05.h"

/* NO CAMBIAR LAS SIGUIENTES DECLARACIONES E IMPLEMENTACIONES */

/* Contexto grfico donde se dibuja */
HDC hImagen;

/* Funciones Auxiliares -- NO cambiar estas funciones */
void Linea( int x_comienzo, int y_comienzo, int x_fin, int y_fin )
{
  MoveToEx( hImagen, x_comienzo, y_comienzo, NULL );
  LineTo( hImagen, x_fin, y_fin );
}

void TrianguloRelleno( PUNTO2 A, PUNTO2 B, PUNTO2 C )
{
  PUNTO2 puntos[3] = {A,B,C};
  Polygon( hImagen, puntos, 3 );
}

void RectanguloRelleno( PUNTO2 A, PUNTO2 B )
{
  Rectangle( hImagen, A.x,A.y, B.x,B.y );
}

void PoligonoRelleno( PUNTO2 *pListaPuntos, int nCantidadPuntos )
{
  Polygon( hImagen, pListaPuntos, nCantidadPuntos );
}

void ElipseRelleno( PUNTO2 supizq, PUNTO2 infder )
{
  Ellipse( hImagen, supizq.x,supizq.y, infder.x,infder.y );
}

void SectorRelleno( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final )
{
  Pie( hImagen, supizq.x,supizq.y, infder.x,infder.y, comienzo.x,comienzo.y, final.x,final.y );
}


void Arco( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final )
{
  Arc( hImagen, supizq.x,supizq.y, infder.x,infder.y, comienzo.x,comienzo.y, final.x,final.y );
}
void CuerdaRellena( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final )
{
  Chord( hImagen, supizq.x,supizq.y, infder.x,infder.y, comienzo.x,comienzo.y, final.x,final.y );
}


void Triangulo( PUNTO2 A, PUNTO2 B, PUNTO2 C )
{
  PUNTO2 puntos[3] = {A,B,C};
  HBRUSH hbr = SelectObject( hImagen, (HBRUSH)GetStockObject(NULL_BRUSH) );

  Polygon( hImagen, puntos, 3 );

  SelectObject( hImagen, hbr );
}

void Rectangulo( PUNTO2 A, PUNTO2 B )
{
  HBRUSH hbr = SelectObject( hImagen, (HBRUSH)GetStockObject(NULL_BRUSH) );
  Rectangle( hImagen, A.x,A.y, B.x,B.y );
  SelectObject( hImagen, hbr );
}

void Poligono( PUNTO2 *pListaPuntos, int nCantidadPuntos )
{
  HBRUSH hbr = SelectObject( hImagen, (HBRUSH)GetStockObject(NULL_BRUSH) );
  Polygon( hImagen, pListaPuntos, nCantidadPuntos );
  SelectObject( hImagen, hbr );
}

void Elipse( PUNTO2 supizq, PUNTO2 infder )
{
  HBRUSH hbr = SelectObject( hImagen, (HBRUSH)GetStockObject(NULL_BRUSH) );
  Ellipse( hImagen, supizq.x,supizq.y, infder.x,infder.y );
  SelectObject( hImagen, hbr );
}

void Cuerda( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final )
{
  HBRUSH hbr = SelectObject( hImagen, (HBRUSH)GetStockObject(NULL_BRUSH) );
  Chord( hImagen, supizq.x,supizq.y, infder.x,infder.y, comienzo.x,comienzo.y, final.x,final.y );
  SelectObject( hImagen, hbr );
}

void Sector( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final )
{
  HBRUSH hbr = SelectObject( hImagen, (HBRUSH)GetStockObject(NULL_BRUSH) );
  Pie( hImagen, supizq.x,supizq.y, infder.x,infder.y, comienzo.x,comienzo.y, final.x,final.y );
  SelectObject( hImagen, hbr );
}

void Bezier( const PUNTO2 *pListaPuntos, unsigned long nPuntos )
{
  PolyBezier( hImagen, pListaPuntos, nPuntos );
}

/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */

/* A continuacin puede cambiar las siguientes declaraciones e implementaciones */

/* Dimensiones de la imagen producida: uiAnchura x uiAltura */
const UINT uiAnchura = 500;
const UINT uiAltura = 500;

/* El/la estudiante se hace cargo de esta funcin y otras creadas por s mismo/a */
void Dibujar( void )
{
  /* A partir de aqu, escribe las sentencias para dibujar */
}

