/* DIBUJAR05.H
**
** Declaracin de Funciones y definicin de Macros auxiliares para programar
** grficos, si el/la estudiante no conoce el API de MS-Windows.
*/

#ifndef _DIBUJAR05_
#define _DIBUJAR05_

/* Definiciones de Macros */
#define COLOR COLORREF
#define PUNTO2 POINT

#define CambiarColorPincel(r,g,b) \
        DeleteObject( (HPEN)SelectObject(hImagen, CreatePen(PS_SOLID, 0, RGB(r,g,b))) )

#define CambiarColorBrocha(r,g,b) \
        DeleteObject( (HBRUSH)SelectObject( hImagen, CreateSolidBrush( RGB(r,g,b) ) ) )

#define PonPixel(x,y,color) \
        SetPixelV( hImagen, x, y, color )

#define TraePixel(x,y) \
        GetPixel( hImagen, x, y )

/* Declaraciones de Funciones */
void Linea( int x_comienzo, int y_comienzo, int x_fin, int y_fin );
void TrianguloRelleno( PUNTO2 A, PUNTO2 B, PUNTO2 C );
void RectanguloRelleno( PUNTO2 A, PUNTO2 B );
void PoligonoRelleno( PUNTO2 *pListaPuntos, int nCantidadPuntos );
void ElipseRelleno( PUNTO2 supizq, PUNTO2 infder );
void CuerdaRellena( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final );
void SectorRelleno( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final );

void Triangulo( PUNTO2 A, PUNTO2 B, PUNTO2 C );
void Rectangulo( PUNTO2 A, PUNTO2 B );
void Poligono( PUNTO2 *pListaPuntos, int nCantidadPuntos );
void Elipse( PUNTO2 supizq, PUNTO2 infder );
void Cuerda( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final );
void Sector( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final );
void Arco( PUNTO2 supizq, PUNTO2 infder, PUNTO2 comienzo, PUNTO2 final );

void Bezier( const PUNTO2 *pListaPuntos, unsigned long nPuntos );

/* Funcin principal para la parte grfica,
** la cual es modificada por el/la programador/a
*/
void Dibujar( void );

#endif

