#include <windows.h>
#include "dibujar05.h"

extern const UINT uiAnchura;
extern const UINT uiAltura;
char szNombreClase[] = "Cap05 - 32 bit";  /* Se puede alterar el nombre si se desea */

HDC hImagen=NULL;

LRESULT CALLBACK WndProc( HWND hWnd, UINT iMensaje, WPARAM wParam, LPARAM lParam );

int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszArgumentos, int nCmd )
{
  HWND hWnd;
  MSG mensajes;
  WNDCLASSEX wc;
  char szTitulo[] = "Captulo 5 - Grficos"; /* Ttulo de la ventana -- Se puede cambiar si se desea */
  
  wc.hInstance = hInst;
  wc.lpszClassName = szNombreClase;
  wc.lpfnWndProc = WndProc;
  wc.style = CS_DBLCLKS | CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.hIcon = LoadIcon( NULL, IDI_APPLICATION );
  wc.hIconSm = LoadIcon( NULL, IDI_APPLICATION );
  wc.hCursor = LoadCursor( NULL, IDC_ARROW );
  wc.lpszMenuName = NULL;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH );

  if( !RegisterClassEx(&wc) )  return 0;

  hWnd = CreateWindowEx( 0,
                         szNombreClase,
                         szTitulo,
                         WS_OVERLAPPED | WS_BORDER | WS_CAPTION | WS_SYSMENU,
                         CW_USEDEFAULT, CW_USEDEFAULT,
                         50, 50,
                         NULL,
                         NULL,
                         hInst,
                         NULL
                       );

  /* Ajustar la ventana para que el rea del cliente sea igual al del BITMAP */
  {
    RECT ventanaRect, clienteRect;
    UINT uiAnchuraVentana=0, uiAlturaVentana=0,
         uiAnchuraCliente=0, uiAlturaCliente=0;

    GetWindowRect( hWnd, &ventanaRect );
    GetClientRect( hWnd, &clienteRect );
    uiAnchuraVentana = ventanaRect.right-ventanaRect.left+1;
    uiAnchuraCliente = clienteRect.right-clienteRect.left+1;
    uiAlturaVentana = ventanaRect.bottom-ventanaRect.top+1;
    uiAlturaCliente = clienteRect.bottom-clienteRect.top+1;

    SetWindowPos( hWnd, HWND_BOTTOM, 0, 0,
                  uiAnchuraVentana + uiAnchura - uiAnchuraCliente,
                  uiAlturaVentana + uiAltura - uiAlturaCliente,
                  SWP_NOZORDER | SWP_NOMOVE
                );
  }

  ShowWindow( hWnd, nCmd );
  UpdateWindow( hWnd );

  while( GetMessage(&mensajes, NULL, 0, 0) )
  {
    TranslateMessage( &mensajes );
    DispatchMessage( &mensajes );
  }

  return mensajes.wParam;
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT iMensaje, WPARAM wParam, LPARAM lParam )
{
/* Bandern para indicar la primera vez que se dibuja */
  static BOOL bPrimera_vez = TRUE;

  switch( iMensaje )
  {
    case WM_CREATE:
    {
      HBITMAP hBitmap;
      RECT rect;
      HDC hDC = GetDC( hWnd );

      hImagen = CreateCompatibleDC( hDC );
      hBitmap = CreateCompatibleBitmap( hDC, uiAnchura, uiAltura );

      SelectObject( hImagen, hBitmap );
      DeleteObject( hBitmap );
      SetMapMode( hImagen, GetMapMode(hDC) );
      ReleaseDC( hWnd, hDC );

      /* Inicializar la imagen */
      rect.top = 0;  rect.left = 0;
      rect.bottom = uiAltura;  rect.right = uiAnchura;
      FillRect( hImagen, &rect, (HBRUSH) GetStockObject(WHITE_BRUSH) );

      SelectObject( hImagen, (HPEN)GetStockObject(WHITE_PEN) );
      SelectObject( hImagen, (HBRUSH)GetStockObject(DKGRAY_BRUSH) );

      return 0;
    }

    case WM_DESTROY:
      DeleteObject( SelectObject( hImagen, (HPEN)GetStockObject(BLACK_PEN) ) );
      DeleteObject( SelectObject( hImagen, (HBRUSH)GetStockObject(WHITE_BRUSH) ) );
      DeleteDC( hImagen );
      PostQuitMessage(0);
      return 0;

    case WM_PAINT:
    {
      PAINTSTRUCT ps;
      HDC hDC = BeginPaint( hWnd, &ps );
        if( bPrimera_vez )
        {
          Dibujar();    /* Funcin predefinida para el/la estudiante */
          bPrimera_vez = FALSE;
        }
        BitBlt( hDC, 0, 0, uiAnchura, uiAltura, hImagen, 0, 0, SRCCOPY );
      EndPaint( hWnd, &ps );
      return 0;
    }
  }

  return DefWindowProc( hWnd, iMensaje, wParam, lParam );
}

